package com.cesgroup.common.utils;

import com.github.pagehelper.Page;

import javax.servlet.http.HttpServletRequest;

/**
 * web层统一返回工具类
 */
public class ApiResultUtil {

    private ApiResultUtil(){}

    /**
     * 获取请求成功响应的ApiResponse
     * @param data
     * @return
     */
    public static ApiResponse getApiResponse(Object data) {
        return getApiResponse(data, ApiResponseEnum.SUCCESS );
    }
    public static ApiResponse getApiResponse(Object data,int code,String msg) {
        ApiResponse dataApiResult = new ApiResponse();
        dataApiResult.setData(data);
        dataApiResult.setErrCode(code);
        dataApiResult.setErrMsg(msg);
        return dataApiResult;
    }
    public static ApiResponse getApiResponse(Object data, ApiResponseEnum apiResponseEnum) {
        ApiResponse dataApiResult = new ApiResponse();
        dataApiResult.setData(data);
        dataApiResult.setErrCode(apiResponseEnum.getErrCode());
        dataApiResult.setErrMsg(apiResponseEnum.getErrMsg());
        return dataApiResult;
    }

    public static JsonDataGrid getApiResponse(Page page,String msg){
        JsonDataGrid j=new JsonDataGrid();
        j.setMsg(msg);
        j.setRows(page.getResult());
        j.setTotal(page.getTotal());
        j.setPageCount(page.getPages());
        j.setPageIndex(page.getPageNum());
        return j;
    }
    public static JsonDataGrid getApiResponse(String state,String msg){
        JsonDataGrid j=new JsonDataGrid();
        j.setMsg(msg);
        j.setState(state);
        return j;
    }
    /**
     *
     * @author HuaZai
     * @contact who.seek.me@java98k.vip
     * @title getUserIP
     *        <ul>
     * @description 获取用户真实的IP地址
     *              </ul>
     * @createdTime 2017年12月30日 下午6:42:17
     * @param request
     * @return String
     *
     * @version : V1.0.0
     */
    public static String getUserIP(HttpServletRequest request){
        String ERROR_IP = "127.0.0.1";
        // 优先取 X-Real-IP
        String ip = request.getHeader("X-Real-IP");
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip))
        {
            ip = request.getHeader("x-forwarded-for");
        }

        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip))
        {
            ip = request.getRemoteAddr();
            if ("0:0:0:0:0:0:0:1".equals(ip))
            {
                ip = ERROR_IP;
            }
        }
        if ("unknown".equalsIgnoreCase(ip))
        {
            ip = ERROR_IP;
            return ip;
        }
        int index = ip.indexOf(',');
        if (index >= 0)
        {
            ip = ip.substring(0, index);
        }

        return ip;
    }

}
