/**
 * eip
 * cn.sh.ideal.core.util.JSONOperateResult.java
 */
package com.cesgroup.common.utils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * 提供给DataGrid控件的JSON对象
 * 
 */
public class JsonDataGrid<T> {

	/** 记录集合* */
	private List<T> rows = new ArrayList<>();
	/** 总记录* */
	private long total = 0;
	// 总页数
	private long pageCount = 0;
	// 当前页
	private int pageIndex = 0;
	private String state;
	private String msg;
	private String title;
	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public String getState() {
		return state;
	}

	public void setState(String state) {
		this.state = state;
	}

	public long getPageCount() {
		return pageCount;
	}

	public void setPageCount(long pageCount) {
		this.pageCount = pageCount;
	}

	public int getPageIndex() {
		return pageIndex;
	}

	public void setPageIndex(int pageIndex) {
		this.pageIndex = pageIndex;
	}

	/**
	 * 添加数据集合
	 * 
	 * @param items
	 */
	public void addAll(Collection<T> items) {
		this.rows.addAll(items);
	}

	/**
	 * 添加数据
	 * 
	 * @param obj
	 */
	public void addItem(T obj) {
		this.rows.add(obj);
	}

	/**
	 * 移除数据
	 * 
	 * @param obj
	 */
	public void removeItem(T obj) {
		this.rows.remove(obj);
	}

	public List<T> getRows() {
		return rows;
	}

	public void setRows(List<T> rows) {
		this.rows = rows;
	}

	public long getTotal() {
		return total;
	}

	/** 总记录* */
	public void setTotal(long total) {
		this.total = total;
	}
}
