package com.cesgroup.kingkong.web;


import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;


public abstract class BaseServiceController<T , Service extends IService<T>>{
	
	@Autowired
	protected Service service;

	public Service getBaseService() {
		return service;
	}
	
	@RequestMapping("/list") 
	public List<T> list(T entity) {
	
		return service.list(Wrappers.<T>query(entity));
	}
	
	@RequestMapping("/query") 
	public IPage<T> query(Page<T> pager,T entity) {
		IPage<T> page = new Page<T>();
		return service.page(page, Wrappers.<T>query(entity));
	}

	@GetMapping("/{id}")
	public T get(@PathVariable String id) {
		return service.getById(id);
	}

	@PostMapping("/save")
	public Boolean save(@RequestBody T user) {
		return service.save(user);
	}

	@PostMapping("/update")
	public Boolean update(@RequestBody T user) {
		return service.updateById(user);
	}

	@DeleteMapping("/{id}")
	public Boolean delete(@PathVariable String id) {
		return service.removeById(id);
	}	
	
	
}
